/* qbtest2.ec - Quadbase test program - complex query */

/* DECLARE SECTION */
EXEC SQL BEGIN DECLARE SECTION
     USING TABLE txn, customer, movie;
     static txn BASED ON txn;
     static customer BASED ON customer;
     static movie BASED ON movie;
     static prompt_cust_no BASED ON CUSTOMER.CUST_NO;
EXEC SQL END DECLARE SECTION;

EXEC SQL INCLUDE SQLCA;

#define NOTFOUND 100

main()
{
     int no_movies;

     /* exception handling */
     EXEC SQL WHENEVER SQLERROR GOTO: error;

     /* open .DBF database files */
     EXEC SQL USE TABLE txn;
     EXEC SQL USE TABLE customer;
     EXEC SQL USE TABLE movie;

     printf("Enter customer number: ");
     gets(prompt_cust_no);
     printf("\n");

     /* Select with UPPER dBASE function */
     EXEC SQL SELECT *
          INTO :customer
          FROM customer
          WHERE customer.cust_no = UPPER(:prompt_cust_no);

     /* show the movies (rented out transactions) for the customer */
     EXEC SQL DECLARE display_movie CURSOR FOR
          SELECT * FROM txn
          WHERE txn.cust_no = :customer.cust_no AND txn.type='O';

     no_movies = 0;
     EXEC SQL OPEN display_movie;
     EXEC SQL FETCH display_movie INTO :txn;
     if (SQLCODE != NOTFOUND) {
          printf("Customer name is %s\n",customer.name);
          printf("Movie #    Rate \n\n");
     }
     else {
          printf("No movies rented out for customer %s\n",customer.name);
          goto finish;
     }
     while (SQLCODE != NOTFOUND) {
          no_movies++;
          printf("%s   %f   \n",txn.item_no,txn.rate);

          EXEC SQL FETCH display_movie INTO :txn;
     }

     printf("Customer %s of %s has %hd movies rented out \n",
             customer.name, customer.city, no_movies);

     finish:
          EXEC SQL CLOSE display_movie;
          return;

     error:
          printf("SQL command failed");
          printf("sqlcode:%d\n",SQLCODE);
          dq_print_messages();  /*detailed message */

}

